﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.Security.Authentication.Web;

namespace weiboWebAuthenticationApp
{
    /// <summary>
    /// 可用于自身或导航至 Frame 内部的空白页。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        private async void OnClick(object sender, RoutedEventArgs e)
        {
            // 你的应用的App key
            string clientID = txtClientID.Text;

            // 你在开放平台上填写的回调URI
            string cbUri = txtCallbackUri.Text;
            Uri callbackUri = new Uri(cbUri);

            // 新浪微博授权地址
            string wbauthUriStr = $"https://api.weibo.com/oauth2/authorize?client_id={clientID}&response_type=code&redirect_uri={cbUri}";

            Uri wbAuthUri = new Uri(wbauthUriStr);

            // 获取授权
            WebAuthenticationResult result = await WebAuthenticationBroker.AuthenticateAsync(WebAuthenticationOptions.None, wbAuthUri, callbackUri);

            // 处理结果
            if (result.ResponseStatus == WebAuthenticationStatus.Success)
            {
                string cburi = result.ResponseData;
                // 取得授权码
                // code是附加在回调URI后，以?code=xxxxxxxxxxxxxx的形式出现，作为URI的查询字符串
                string code = cburi.Substring(cburi.IndexOf('=') + 1);

                tbmsg.Text = $"回调URI：{cburi}\n授权码：{code}";
            }
            else if (result.ResponseStatus == WebAuthenticationStatus.ErrorHttp)
            {
                tbmsg.Text = "错误：" + result.ResponseErrorDetail.ToString();
            }
            else if (result.ResponseStatus == WebAuthenticationStatus.UserCancel)
            {
                tbmsg.Text = "你取消了操作。";
            }
        }
    }
}
